## looking-glass 0+b3+dfsg.1

=== client/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.0)
project(looking-glass-client C)

set(CMAKE_MODULE_PATH "${PROJECT_SOURCE_DIR}/cmake/")

include(GNUInstallDirs)
include(CheckCCompilerFlag)
include(FeatureSummary)

option(OPTIMIZE_FOR_NATIVE "Build with -march=native" ON)
if(OPTIMIZE_FOR_NATIVE)
  CHECK_C_COMPILER_FLAG("-march=native" COMPILER_SUPPORTS_MARCH_NATIVE)
  if(COMPILER_SUPPORTS_MARCH_NATIVE)
    add_compile_options("-march=native")
  endif()
endif()

option(ENABLE_OPENGL "Enable the OpenGL renderer"       ON)
add_feature_info(ENABLE_OPENGL ENABLE_OPENGL "Legacy OpenGL renderer.")

option(ENABLE_EGL    "Enable the EGL renderer"          ON)
add_feature_info(ENABLE_EGL ENABLE_EGL "EGL renderer.")

option(ENABLE_BACKTRACE "Enable backtrace support on crash" ON)
add_feature_info(ENABLE_BACKTRACE ENABLE_BACKTRACE "Backtrace support.")

option(ENABLE_ASAN "Build with AddressSanitizer" OFF)
add_feature_info(ENABLE_ASAN ENABLE_ASAN "AddressSanitizer support.")

option(ENABLE_UBSAN "Build with UndefinedBehaviorSanitizer" OFF)
add_feature_info(ENABLE_UBSAN ENABLE_UBSAN "UndefinedBehaviorSanitizer support.")

option(ENABLE_X11 "Build with X11 support" ON)
add_feature_info(ENABLE_X11 ENABLE_X11 "X11 support.")

option(ENABLE_WAYLAND "Build with Wayland support" ON)
add_feature_info(ENABLE_WAYLAND ENABLE_WAYLAND "Wayland support.")

add_compile_options(
  "-Wall"
  "-Wextra"
  "-Wno-sign-compare"
  "-Wno-unused-parameter"
  "$<$<C_COMPILER_ID:GNU>:-Wimplicit-fallthrough=2>"
  "-Werror"
  "-Wfatal-errors"
  "-ffast-math"
  "-fdata-sections"
  "-ffunction-sections"
  "$<$<CONFIG:DEBUG>:-O0;-g3;-ggdb>"
)

set(EXE_FLAGS "-Wl,--gc-sections -z noexecstack")
set(CMAKE_C_STANDARD 11)

if(ENABLE_ASAN)
  add_compile_options("-fno-omit-frame-pointer" "-fsanitize=address")
  set(EXE_FLAGS "${EXE_FLAGS} -fno-omit-frame-pointer -fsanitize=address")
endif()

if(ENABLE_UBSAN)
  add_compile_options("-fsanitize=undefined")
  set(EXE_FLAGS "${EXE_FLAGS} -fsanitize=undefined")
endif()

find_package(PkgConfig)
pkg_check_modules(PKGCONFIG REQUIRED
	sdl2
)

find_package(GMP)

add_definitions(-D ATOMIC_LOCKING)
add_definitions(-D GL_GLEXT_PROTOTYPES)
get_filename_component(PROJECT_TOP "${PROJECT_SOURCE_DIR}/.." ABSOLUTE)

add_custom_command(
	OUTPUT	${CMAKE_BINARY_DIR}/version.c
		${CMAKE_BINARY_DIR}/_version.c
	COMMAND ${CMAKE_COMMAND} -D PROJECT_TOP=${PROJECT_TOP} -P
		${PROJECT_TOP}/version.cmake
)

include_directories(
	${PROJECT_SOURCE_DIR}/include
	${CMAKE_BINARY_DIR}/include
	${PKGCONFIG_INCLUDE_DIRS} ${PKGCONFIG_OPT_INCLUDE_DIRS}
	${GMP_INCLUDE_DIR}
)

link_libraries(
	${PKGCONFIG_LIBRARIES} ${PKGCONFIG_OPT_LIBRARIES}
	${GMP_LIBRARIES}
	${CMAKE_DL_LIBS}
	rt
	m
)

set(SOURCES
	${CMAKE_BINARY_DIR}/version.c
	src/main.c
	src/app.c
	src/config.c
	src/lg-renderer.c
	src/ll.c
	src/utils.c
)

add_subdirectory("${PROJECT_TOP}/common"          "${CMAKE_BINARY_DIR}/common"   )
add_subdirectory("${PROJECT_TOP}/repos/LGMP/lgmp" "${CMAKE_BINARY_DIR}/LGMP"     )
add_subdirectory("${PROJECT_TOP}/repos/PureSpice" "${CMAKE_BINARY_DIR}/PureSpice")

add_subdirectory(displayservers)
add_subdirectory(renderers)
add_subdirectory(fonts)

add_executable(looking-glass-client ${SOURCES})
target_compile_options(looking-glass-client PUBLIC ${PKGCONFIG_CFLAGS_OTHER} ${PKGCONFIG_OPT_CFLAGS_OTHER})
target_link_libraries(looking-glass-client
	${EXE_FLAGS}
	lg_common
	displayservers
	lgmp
	purespice
	renderers
	fonts
)

install(PROGRAMS ${CMAKE_BINARY_DIR}/looking-glass-client DESTINATION bin/ COMPONENT binary)

feature_summary(WHAT ENABLED_FEATURES DISABLED_FEATURES)

=== common/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.0)
project(lg_common LANGUAGES C)

include_directories(
	${PROJECT_SOURCE_DIR}/include
)

add_definitions(-D_GNU_SOURCE)

if(ENABLE_BACKTRACE)
  add_definitions(-DENABLE_BACKTRACE)
endif()

add_subdirectory(src/platform)

set(COMMON_SOURCES
  src/stringutils.c
  src/stringlist.c
  src/option.c
  src/framebuffer.c
  src/KVMFR.c
)

add_library(lg_common STATIC ${COMMON_SOURCES})
target_link_libraries(lg_common lg_common_platform)

target_include_directories(lg_common
	INTERFACE
		include
	PRIVATE
		src
)

=== host/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.0)
project(looking-glass-host C)

set(CMAKE_MODULE_PATH "${PROJECT_SOURCE_DIR}/cmake/")

include(CheckCCompilerFlag)
include(FeatureSummary)

option(OPTIMIZE_FOR_NATIVE "Build with -march=native" OFF)
if(OPTIMIZE_FOR_NATIVE)
  CHECK_C_COMPILER_FLAG("-march=native" COMPILER_SUPPORTS_MARCH_NATIVE)
  if(COMPILER_SUPPORTS_MARCH_NATIVE)
    add_compile_options("-march=native")
  endif()
else()
  CHECK_C_COMPILER_FLAG("-march=nehalem" COMPILER_SUPPORTS_MARCH_NEHALEM)
  if(COMPILER_SUPPORTS_MARCH_NEHALEM)
    add_compile_options("-march=nehalem")
  endif()
endif()

option(ENABLE_BACKTRACE "Enable backtrace support on crash" ON)
add_feature_info(ENABLE_BACKTRACE ENABLE_BACKTRACE "Backtrace support.")

add_compile_options(
  "-Wall"
  "-Werror"
  "-Wfatal-errors"
  "-ffast-math"
  "-fdata-sections"
  "-ffunction-sections"
  "$<$<CONFIG:DEBUG>:-O0;-g3;-ggdb>"
)
set(CMAKE_C_STANDARD  11)

get_filename_component(PROJECT_TOP "${PROJECT_SOURCE_DIR}/.." ABSOLUTE)

add_custom_command(
	OUTPUT	${CMAKE_BINARY_DIR}/version.c
		${CMAKE_BINARY_DIR}/_version.c
	COMMAND ${CMAKE_COMMAND} -D PROJECT_TOP=${PROJECT_TOP} -P
		${PROJECT_TOP}/version.cmake
)

include_directories(
	${PROJECT_SOURCE_DIR}/include
	${CMAKE_BINARY_DIR}/include
	${PKGCONFIG_INCLUDE_DIRS}
	${GMP_INCLUDE_DIR}
)

#link_libraries(
#)

set(SOURCES
	${CMAKE_BINARY_DIR}/version.c
	src/app.c
)

add_subdirectory("${PROJECT_TOP}/common"          "${CMAKE_BINARY_DIR}/common")
add_subdirectory("${PROJECT_TOP}/repos/LGMP/lgmp" "${CMAKE_BINARY_DIR}/lgmp"  )
add_subdirectory(platform)

if(WIN32)
  add_executable(looking-glass-host WIN32 ${SOURCES})
else()
  add_executable(looking-glass-host ${SOURCES})
endif()
target_link_libraries(looking-glass-host
	lg_common
	platform
	lgmp
)

if(WIN32)
  set_target_properties(looking-glass-host PROPERTIES LINK_FLAGS "-Wl,--gc-sections -Wl,--nxcompat")
else()
  set_target_properties(looking-glass-host PROPERTIES LINK_FLAGS "-Wl,--gc-sections -z noexecstack")
endif()

install(PROGRAMS ${CMAKE_BINARY_DIR}/looking-glass-host DESTINATION bin/ COMPONENT binary)

feature_summary(WHAT ENABLED_FEATURES DISABLED_FEATURES)

=== obs/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.0)
project(looking-glass-obs C)

set(CMAKE_MODULE_PATH "${PROJECT_SOURCE_DIR}/cmake/")

include(GNUInstallDirs)
include(CheckCCompilerFlag)
include(FeatureSummary)

option(OPTIMIZE_FOR_NATIVE "Build with -march=native" ON)
if(OPTIMIZE_FOR_NATIVE)
  CHECK_C_COMPILER_FLAG("-march=native" COMPILER_SUPPORTS_MARCH_NATIVE)
  if(COMPILER_SUPPORTS_MARCH_NATIVE)
    add_compile_options("-march=native")
  endif()
endif()

option(ENABLE_BACKTRACE "Enable backtrace support on crash" ON)
add_feature_info(ENABLE_BACKTRACE ENABLE_BACKTRACE "Backtrace support.")

add_compile_options(
  "-Wall"
  "-Werror"
  "-Wfatal-errors"
  "-ffast-math"
  "-fdata-sections"
  "-ffunction-sections"
  "-fpic"
  "$<$<CONFIG:DEBUG>:-O0;-g3;-ggdb>"
)

set(EXE_FLAGS "-Wl,--gc-sections")
set(CMAKE_C_STANDARD 11)

add_definitions(-D ATOMIC_LOCKING)
get_filename_component(PROJECT_TOP "${PROJECT_SOURCE_DIR}/.." ABSOLUTE)

add_custom_command(
	OUTPUT	${CMAKE_BINARY_DIR}/version.c
		${CMAKE_BINARY_DIR}/_version.c
	COMMAND ${CMAKE_COMMAND} -D PROJECT_TOP=${PROJECT_TOP} -P
		${PROJECT_TOP}/version.cmake
)

include_directories(
	${PROJECT_SOURCE_DIR}/include
	${CMAKE_BINARY_DIR}/include
)

link_libraries(
	${CMAKE_DL_LIBS}
	rt
	m
)

set(SOURCES
	${CMAKE_BINARY_DIR}/version.c
	main.c
	lg.c
)

add_subdirectory("${PROJECT_TOP}/common"          "${CMAKE_BINARY_DIR}/common")
add_subdirectory("${PROJECT_TOP}/repos/LGMP/lgmp" "${CMAKE_BINARY_DIR}/lgmp"  )

add_library(looking-glass-obs SHARED ${SOURCES})
target_link_libraries(looking-glass-obs
	${EXE_FLAGS}
	lg_common
	lgmp
)

feature_summary(WHAT ENABLED_FEATURES DISABLED_FEATURES)

=== client/displayservers/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.0)
project(displayservers LANGUAGES C)

set(DISPLAYSERVER_H "${CMAKE_BINARY_DIR}/include/dynamic/displayservers.h")
set(DISPLAYSERVER_C "${CMAKE_BINARY_DIR}/src/displayservers.c")

file(WRITE  ${DISPLAYSERVER_H} "#include \"interface/displayserver.h\"\n\n")
file(APPEND ${DISPLAYSERVER_H} "extern struct LG_DisplayServerOps * LG_DisplayServers[];\n\n")

file(WRITE  ${DISPLAYSERVER_C} "#include \"interface/displayserver.h\"\n\n")
file(APPEND ${DISPLAYSERVER_C} "#include <stddef.h>\n\n")

set(DISPLAYSERVERS "_")
set(DISPLAYSERVERS_LINK "_")
function(add_displayserver name)
  set(DISPLAYSERVERS      "${DISPLAYSERVERS};${name}" PARENT_SCOPE)
  set(DISPLAYSERVERS_LINK "${DISPLAYSERVERS_LINK};displayserver_${name}" PARENT_SCOPE)
  add_subdirectory(${name})
endfunction()

# SDL must be first as it's the default implementation!
add_displayserver(SDL)

# Add/remove displayservers here!
if (ENABLE_X11)
  add_displayserver(X11)
endif()

if (ENABLE_WAYLAND)
  add_displayserver(Wayland)
endif()

list(REMOVE_AT DISPLAYSERVERS      0)
list(REMOVE_AT DISPLAYSERVERS_LINK 0)

list(LENGTH DISPLAYSERVERS DISPLAYSERVER_COUNT)
file(APPEND ${DISPLAYSERVER_H} "#define LG_DISPLAYSERVER_COUNT ${DISPLAYSERVER_COUNT}\n")

foreach(displayserver ${DISPLAYSERVERS})
  file(APPEND ${DISPLAYSERVER_C} "extern struct LG_DisplayServerOps LGDS_${displayserver};\n")
endforeach()

file(APPEND ${DISPLAYSERVER_C} "\nconst struct LG_DisplayServerOps * LG_DisplayServers[] =\n{\n")
foreach(displayserver ${DISPLAYSERVERS})
  file(APPEND ${DISPLAYSERVER_C} "  &LGDS_${displayserver},\n")
endforeach()
file(APPEND ${DISPLAYSERVER_C} "  NULL\n};")

add_library(displayservers STATIC ${DISPLAYSERVER_C})
target_link_libraries(displayservers ${DISPLAYSERVERS_LINK})

=== client/displayservers/SDL/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.0)
project(displayserver_SDL LANGUAGES C)

#find_package(PkgConfig)
#pkg_check_modules(DISPLAYSERVER_SDL_PKGCONFIG REQUIRED
#	#sdl2
#)

add_library(displayserver_SDL STATIC
	sdl.c
)

target_link_libraries(displayserver_SDL
	${DISPLAYSERVER_SDL_PKGCONFIG_LIBRARIES}
	${DISPLAYSERVER_SDL_OPT_PKGCONFIG_LIBRARIES}
	lg_common
)

target_include_directories(displayserver_SDL
	PRIVATE
		src
		${DISPLAYSERVER_SDL_PKGCONFIG_INCLUDE_DIRS}
		${DISPLAYSERVER_SDL_OPT_PKGCONFIG_INCLUDE_DIRS}
)

=== client/displayservers/Wayland/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.0)
project(displayserver_Wayland LANGUAGES C)

find_package(PkgConfig)
pkg_check_modules(DISPLAYSERVER_Wayland_PKGCONFIG REQUIRED
	wayland-client
)

#pkg_check_modules(DISPLAYSERVER_Wayland_OPT_PKGCONFIG
#)

add_library(displayserver_Wayland STATIC
	wayland.c
)

target_link_libraries(displayserver_Wayland
	${DISPLAYSERVER_Wayland_PKGCONFIG_LIBRARIES}
	${DISPLAYSERVER_Wayland_OPT_PKGCONFIG_LIBRARIES}
	lg_common
)

target_include_directories(displayserver_Wayland
	PRIVATE
		src
		${DISPLAYSERVER_Wayland_PKGCONFIG_INCLUDE_DIRS}
		${DISPLAYSERVER_Wayland_OPT_PKGCONFIG_INCLUDE_DIRS}
)

find_program(WAYLAND_SCANNER_EXECUTABLE NAMES wayland-scanner)
pkg_check_modules(WAYLAND_PROTOCOLS REQUIRED wayland-protocols>=1.15)
pkg_get_variable(WAYLAND_PROTOCOLS_BASE wayland-protocols pkgdatadir)

macro(wayland_generate protocol_file output_file)
    add_custom_command(OUTPUT "${output_file}.h"
        COMMAND "${WAYLAND_SCANNER_EXECUTABLE}" client-header "${protocol_file}" "${output_file}.h"
        DEPENDS "${protocol_file}"
        VERBATIM)

    add_custom_command(OUTPUT "${output_file}.c"
        COMMAND "${WAYLAND_SCANNER_EXECUTABLE}" private-code "${protocol_file}" "${output_file}.c"
        DEPENDS "${protocol_file}"
        VERBATIM)

    target_sources(displayserver_Wayland PRIVATE "${output_file}.h" "${output_file}.c")
endmacro()

file(MAKE_DIRECTORY "${CMAKE_BINARY_DIR}/wayland")
include_directories("${CMAKE_BINARY_DIR}/wayland")
wayland_generate(
    "${WAYLAND_PROTOCOLS_BASE}/unstable/relative-pointer/relative-pointer-unstable-v1.xml"
    "${CMAKE_BINARY_DIR}/wayland/wayland-relative-pointer-unstable-v1-client-protocol")
wayland_generate(
    "${WAYLAND_PROTOCOLS_BASE}/unstable/pointer-constraints/pointer-constraints-unstable-v1.xml"
    "${CMAKE_BINARY_DIR}/wayland/wayland-pointer-constraints-unstable-v1-client-protocol")
wayland_generate(
    "${WAYLAND_PROTOCOLS_BASE}/unstable/keyboard-shortcuts-inhibit/keyboard-shortcuts-inhibit-unstable-v1.xml"
    "${CMAKE_BINARY_DIR}/wayland/wayland-keyboard-shortcuts-inhibit-unstable-v1-client-protocol")
wayland_generate(
    "${WAYLAND_PROTOCOLS_BASE}/unstable/idle-inhibit/idle-inhibit-unstable-v1.xml"
    "${CMAKE_BINARY_DIR}/wayland/wayland-idle-inhibit-unstable-v1-client-protocol")

=== client/displayservers/X11/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.0)
project(displayserver_X11 LANGUAGES C)

find_package(PkgConfig)
pkg_check_modules(DISPLAYSERVER_X11_PKGCONFIG REQUIRED
	x11
	xi
	xfixes
	xscrnsaver
)

add_library(displayserver_X11 STATIC
	x11.c
)

target_link_libraries(displayserver_X11
	${DISPLAYSERVER_X11_PKGCONFIG_LIBRARIES}
	lg_common
)

target_include_directories(displayserver_X11
	PRIVATE
		src
		${DISPLAYSERVER_X11_PKGCONFIG_INCLUDE_DIRS}
)

=== client/renderers/EGL/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.0)
project(renderer_EGL LANGUAGES C)

find_package(PkgConfig)
pkg_check_modules(RENDERER_EGL_PKGCONFIG REQUIRED
	egl
	gl
)

pkg_check_modules(RENDERER_EGL_OPT_PKGCONFIG
	wayland-egl
)

include(MakeObject)
make_object(
	EGL_SHADER
	shader/desktop.vert
	shader/desktop_rgb.frag
	shader/cursor.vert
	shader/cursor_rgb.frag
	shader/cursor_mono.frag
	shader/fps.vert
	shader/fps.frag
	shader/fps_bg.frag
	shader/alert.vert
	shader/alert.frag
	shader/alert_bg.frag
	shader/splash_bg.vert
	shader/splash_bg.frag
	shader/splash_logo.vert
	shader/splash_logo.frag
)

add_library(renderer_EGL STATIC
	egl.c
	dynprocs.c
	egldebug.c
	shader.c
	texture.c
	model.c
	desktop.c
	cursor.c
	fps.c
	draw.c
	splash.c
	alert.c
	${EGL_SHADER_OBJS}
)

target_link_libraries(renderer_EGL
	${RENDERER_EGL_PKGCONFIG_LIBRARIES}
	${RENDERER_EGL_OPT_PKGCONFIG_LIBRARIES}
	lg_common
	fonts
)

target_include_directories(renderer_EGL
	PRIVATE
		src
		${EGL_SHADER_INCS}
		${RENDERER_EGL_PKGCONFIG_INCLUDE_DIRS}
		${RENDERER_EGL_OPT_PKGCONFIG_INCLUDE_DIRS}
)

=== host/platform/Linux/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.0)
project(platform_Linux LANGUAGES C)

include_directories(
	${PROJECT_SOURCE_DIR}/include
)

add_library(platform_Linux STATIC
	src/platform.c
)

add_subdirectory("capture")

target_link_libraries(platform_Linux
	capture
	pthread
	X11
	GL
)

target_include_directories(platform_Linux
	PRIVATE
		src
)

=== host/platform/Windows/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.0)
project(platform_Windows LANGUAGES C)

include_directories(
	${PROJECT_SOURCE_DIR}/include
)

add_library(platform_Windows STATIC
	src/platform.c
	src/service.c
	src/mousehook.c
	src/force_compose.c
)

# allow use of functions for Windows Vista or later
add_definitions(-D _WIN32_WINNT=0x6000)

add_subdirectory("capture")

FIND_PROGRAM(WINDRES_EXECUTABLE NAMES "x86_64-w64-mingw32-windres" "windres.exe" DOC "windres executable")
ADD_CUSTOM_COMMAND(TARGET platform_Windows POST_BUILD
	WORKING_DIRECTORY "${PROJECT_SOURCE_DIR}"
	COMMAND ${WINDRES_EXECUTABLE} -i resource.rc -o "${PROJECT_BINARY_DIR}/resource.o"
	VERBATIM
)

target_link_libraries(platform_Windows
	"${PROJECT_BINARY_DIR}/resource.o"
	lg_common
	capture

	userenv
	wtsapi32
	psapi
	shlwapi
)

target_include_directories(platform_Windows
	PRIVATE
		src
)

# these are for the nsis installer generator
configure_file("${PROJECT_SOURCE_DIR}/installer.nsi" "${PROJECT_BINARY_DIR}/installer.nsi" COPYONLY)
configure_file("${PROJECT_TOP}/resources/icon.ico"   "${PROJECT_BINARY_DIR}/icon.ico"      COPYONLY)
configure_file("${PROJECT_TOP}/LICENSE"              "${PROJECT_BINARY_DIR}/LICENSE.txt"   COPYONLY)

=== common/src/platform/linux/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.0)
project(lg_common_platform_code LANGUAGES C)

include_directories(
	${PROJECT_SOURCE_DIR}/include
	${PROJECT_TOP}
)

add_library(lg_common_platform_code STATIC
    crash.c
    sysinfo.c
    thread.c
    event.c
    ivshmem.c
    time.c
)

if(ENABLE_BACKTRACE)
  target_link_libraries(lg_common_platform_code bfd)
endif()

target_link_libraries(lg_common_platform_code
	lg_common
	pthread
	rt
)

=== debian/changelog ===
looking-glass (0+b3+dfsg.1-1) unstable; urgency=medium

  * New upstream release

 -- Lennart Weller <lhw@ring0.de>  Sun, 28 Mar 2021 16:15:39 +0200

## looking-glass 0+b4+dfsg.1

=== client/CMakeLists.txt ===
--- 
+++ 
@@ -1,7 +1,7 @@
 cmake_minimum_required(VERSION 3.0)
 project(looking-glass-client C)
 
-set(CMAKE_MODULE_PATH "${PROJECT_SOURCE_DIR}/cmake/")
+list(APPEND CMAKE_MODULE_PATH "${PROJECT_SOURCE_DIR}/cmake/")
 
 include(GNUInstallDirs)
 include(CheckCCompilerFlag)
@@ -13,6 +13,8 @@
   if(COMPILER_SUPPORTS_MARCH_NATIVE)
     add_compile_options("-march=native")
   endif()
+else()
+  add_compile_options("-march=nehalem" "-mtune=generic")
 endif()
 
 option(ENABLE_OPENGL "Enable the OpenGL renderer"       ON)
@@ -30,11 +32,21 @@
 option(ENABLE_UBSAN "Build with UndefinedBehaviorSanitizer" OFF)
 add_feature_info(ENABLE_UBSAN ENABLE_UBSAN "UndefinedBehaviorSanitizer support.")
 
+option(ENABLE_SDL "Build with SDL support" OFF)
+add_feature_info(ENABLE_SDL ENABLE_SDL "SDL support.")
+
 option(ENABLE_X11 "Build with X11 support" ON)
 add_feature_info(ENABLE_X11 ENABLE_X11 "X11 support.")
 
 option(ENABLE_WAYLAND "Build with Wayland support" ON)
 add_feature_info(ENABLE_WAYLAND ENABLE_WAYLAND "Wayland support.")
+
+option(ENABLE_LIBDECOR "Build with libdecor support" OFF)
+add_feature_info(ENABLE_LIBDECOR ENABLE_LIBDECOR "libdecor support.")
+
+if (NOT ENABLE_SDL AND NOT ENABLE_X11 AND NOT ENABLE_WAYLAND)
+  message(FATAL_ERROR "One of ENABLE_SDL, ENABLE_X11, or ENABLE_WAYLAND must be on")
+endif()
 
 add_compile_options(
   "-Wall"
@@ -53,6 +65,14 @@
 set(EXE_FLAGS "-Wl,--gc-sections -z noexecstack")
 set(CMAKE_C_STANDARD 11)
 
+if (ENABLE_OPENGL)
+  add_definitions(-D ENABLE_OPENGL)
+endif()
+
+if (ENABLE_EGL)
+  add_definitions(-D ENABLE_EGL)
+endif()
+
 if(ENABLE_ASAN)
   add_compile_options("-fno-omit-frame-pointer" "-fsanitize=address")
   set(EXE_FLAGS "${EXE_FLAGS} -fno-omit-frame-pointer -fsanitize=address")
@@ -62,11 +82,6 @@
   add_compile_options("-fsanitize=undefined")
   set(EXE_FLAGS "${EXE_FLAGS} -fsanitize=undefined")
 endif()
-
-find_package(PkgConfig)
-pkg_check_modules(PKGCONFIG REQUIRED
-	sdl2
-)
 
 find_package(GMP)
 
@@ -84,12 +99,10 @@
 include_directories(
 	${PROJECT_SOURCE_DIR}/include
 	${CMAKE_BINARY_DIR}/include
-	${PKGCONFIG_INCLUDE_DIRS} ${PKGCONFIG_OPT_INCLUDE_DIRS}
 	${GMP_INCLUDE_DIR}
 )
 
 link_libraries(
-	${PKGCONFIG_LIBRARIES} ${PKGCONFIG_OPT_LIBRARIES}
 	${GMP_LIBRARIES}
 	${CMAKE_DL_LIBS}
 	rt
@@ -99,11 +112,16 @@
 set(SOURCES
 	${CMAKE_BINARY_DIR}/version.c
 	src/main.c
+	src/core.c
 	src/app.c
 	src/config.c
+	src/keybind.c
 	src/lg-renderer.c
 	src/ll.c
-	src/utils.c
+	src/util.c
+	src/clipboard.c
+	src/kb.c
+	src/egl_dynprocs.c
 )
 
 add_subdirectory("${PROJECT_TOP}/common"          "${CMAKE_BINARY_DIR}/common"   )
@@ -115,7 +133,6 @@
 add_subdirectory(fonts)
 
 add_executable(looking-glass-client ${SOURCES})
-target_compile_options(looking-glass-client PUBLIC ${PKGCONFIG_CFLAGS_OTHER} ${PKGCONFIG_OPT_CFLAGS_OTHER})
 target_link_libraries(looking-glass-client
 	${EXE_FLAGS}
 	lg_common
@@ -126,6 +143,8 @@
 	fonts
 )
 
-install(PROGRAMS ${CMAKE_BINARY_DIR}/looking-glass-client DESTINATION bin/ COMPONENT binary)
+install(TARGETS looking-glass-client
+	RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
+	COMPONENT binary)
 
 feature_summary(WHAT ENABLED_FEATURES DISABLED_FEATURES)

=== host/CMakeLists.txt ===
--- 
+++ 
@@ -1,8 +1,12 @@
 cmake_minimum_required(VERSION 3.0)
 project(looking-glass-host C)
 
+set(CMAKE_C_FLAGS_RELWITHDEBINFO "-O3 -g -DNDEBUG" CACHE STRING "compiler flags" FORCE)
+set(CMAKE_CXX_FLAGS_RELWITHDEBINFO "-O3 -g -DNDEBUG" CACHE STRING "compiler flags" FORCE)
+
 set(CMAKE_MODULE_PATH "${PROJECT_SOURCE_DIR}/cmake/")
 
+include(GNUInstallDirs)
 include(CheckCCompilerFlag)
 include(FeatureSummary)
 
@@ -78,6 +82,8 @@
   set_target_properties(looking-glass-host PROPERTIES LINK_FLAGS "-Wl,--gc-sections -z noexecstack")
 endif()
 
-install(PROGRAMS ${CMAKE_BINARY_DIR}/looking-glass-host DESTINATION bin/ COMPONENT binary)
+install(TARGETS looking-glass-host
+	RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
+	COMPONENT binary)
 
 feature_summary(WHAT ENABLED_FEATURES DISABLED_FEATURES)

=== obs/CMakeLists.txt ===
--- 
+++ 
@@ -31,6 +31,23 @@
 
 set(EXE_FLAGS "-Wl,--gc-sections")
 set(CMAKE_C_STANDARD 11)
+
+if(CMAKE_SIZEOF_VOID_P EQUAL 8)
+	set(OBS_PLUGIN_DIR 64bit)
+else()
+	set(OBS_PLUGIN_DIR 32bit)
+endif()
+
+if(USER_INSTALL)
+	if(DEFINED ENV{XDG_CONFIG_HOME})
+		set(OBS_PLUGIN_PREFIX $ENV{XDG_CONFIG_HOME})
+	else()
+		set(OBS_PLUGIN_PREFIX $ENV{HOME}/.config)
+	endif()
+	set(OBS_PLUGIN_PREFIX ${OBS_PLUGIN_PREFIX}/obs-studio/plugins)
+else()
+	set(OBS_PLUGIN_PREFIX ${CMAKE_INSTALL_DATADIR}/obs/obs-plugins)
+endif()
 
 add_definitions(-D ATOMIC_LOCKING)
 get_filename_component(PROJECT_TOP "${PROJECT_SOURCE_DIR}/.." ABSOLUTE)
@@ -69,4 +86,8 @@
 	lgmp
 )
 
+install(TARGETS looking-glass-obs
+	LIBRARY DESTINATION ${OBS_PLUGIN_PREFIX}/${CMAKE_PROJECT_NAME}/bin/${OBS_PLUGIN_DIR}
+)
+
 feature_summary(WHAT ENABLED_FEATURES DISABLED_FEATURES)

=== client/displayservers/CMakeLists.txt ===
--- 
+++ 
@@ -18,16 +18,18 @@
   add_subdirectory(${name})
 endfunction()
 
-# SDL must be first as it's the default implementation!
-add_displayserver(SDL)
+# Add/remove displayservers here!
+if (ENABLE_WAYLAND)
+  add_displayserver(Wayland)
+endif()
 
-# Add/remove displayservers here!
 if (ENABLE_X11)
   add_displayserver(X11)
 endif()
 
-if (ENABLE_WAYLAND)
-  add_displayserver(Wayland)
+# SDL must be last as it's the fallback implemntation
+if (ENABLE_SDL)
+  add_displayserver(SDL)
 endif()
 
 list(REMOVE_AT DISPLAYSERVERS      0)

=== client/fonts/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.0)
project(fonts LANGUAGES C)

set(FONT_H "${CMAKE_BINARY_DIR}/include/dynamic/fonts.h")
set(FONT_C "${CMAKE_BINARY_DIR}/src/fonts.c")

file(WRITE  ${FONT_H} "#include \"interface/font.h\"\n\n")
file(APPEND ${FONT_H} "extern LG_Font * LG_Fonts[];\n\n")

file(WRITE  ${FONT_C} "#include \"interface/font.h\"\n\n")
file(APPEND ${FONT_C} "#include <stddef.h>\n\n")

set(FONTS "_")
set(FONTS_LINK "_")
function(add_font name)
  set(FONTS      "${FONTS};${name}" PARENT_SCOPE)
  set(FONTS_LINK "${FONTS_LINK};font_${name}" PARENT_SCOPE)
  add_subdirectory(${name})
endfunction()

# Add/remove fonts here!
add_font(freetype)

list(REMOVE_AT FONTS      0)
list(REMOVE_AT FONTS_LINK 0)

list(LENGTH FONTS FONT_COUNT)
file(APPEND ${FONT_H} "#define LG_FONT_COUNT ${FONT_COUNT}\n")

foreach(font ${FONTS})
  file(APPEND ${FONT_C} "extern LG_Font LGF_${font};\n")
endforeach()

file(APPEND ${FONT_C} "\nconst LG_Font * LG_Fonts[] =\n{\n")
foreach(font ${FONTS})
  file(APPEND ${FONT_C} "  &LGF_${font},\n")
endforeach()
file(APPEND ${FONT_C} "  NULL\n};\n\n")

add_library(fonts STATIC ${FONT_C})
target_link_libraries(fonts ${FONTS_LINK})

=== host/platform/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.0)
project(platform LANGUAGES C)

if (UNIX)
  set(PLATFORM "Linux")
elseif(WIN32)
  set(PLATFORM "Windows")
endif()

add_subdirectory(${PLATFORM})

add_library(platform INTERFACE)
target_link_libraries(platform INTERFACE platform_${PLATFORM})

=== profile/client/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.0)
project(profiler-client C)

set(CMAKE_MODULE_PATH "${PROJECT_SOURCE_DIR}/cmake/")

include(GNUInstallDirs)
include(CheckCCompilerFlag)
include(FeatureSummary)

option(OPTIMIZE_FOR_NATIVE "Build with -march=native" ON)
if(OPTIMIZE_FOR_NATIVE)
  CHECK_C_COMPILER_FLAG("-march=native" COMPILER_SUPPORTS_MARCH_NATIVE)
  if(COMPILER_SUPPORTS_MARCH_NATIVE)
    add_compile_options("-march=native")
  endif()
endif()

add_compile_options(
  "-Wall"
  "-Werror"
  "-Wfatal-errors"
  "-ffast-math"
  "-fdata-sections"
  "-ffunction-sections"
  "$<$<CONFIG:DEBUG>:-O0;-g3;-ggdb>"
)

set(EXE_FLAGS "-Wl,--gc-sections")
set(CMAKE_C_STANDARD 11)

execute_process(
	COMMAND			cat ../../VERSION
	WORKING_DIRECTORY	${PROJECT_SOURCE_DIR}
	OUTPUT_VARIABLE		BUILD_VERSION
	OUTPUT_STRIP_TRAILING_WHITESPACE
)

add_definitions(-D BUILD_VERSION='"${BUILD_VERSION}"')
get_filename_component(PROJECT_TOP "${PROJECT_SOURCE_DIR}/../.." ABSOLUTE)

include_directories(
	${PROJECT_SOURCE_DIR}/include
	${CMAKE_BINARY_DIR}/include
)

link_libraries(
	rt
	m
)

set(SOURCES
	src/main.c
)

add_subdirectory("${PROJECT_TOP}/common"          "${CMAKE_BINARY_DIR}/common")
add_subdirectory("${PROJECT_TOP}/repos/LGMP/lgmp" "${CMAKE_BINARY_DIR}/lgmp"  )

add_executable(profiler-client ${SOURCES})
target_compile_options(profiler-client PUBLIC ${PKGCONFIG_CFLAGS_OTHER})
target_link_libraries(profiler-client
	${EXE_FLAGS}
	lg_common
	lgmp
)

feature_summary(WHAT ENABLED_FEATURES DISABLED_FEATURES)

=== repos/PureSpice/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.0)
project(purespice LANGUAGES C)
set(CMAKE_C_STANDARD 11)

find_package(PkgConfig)
pkg_check_modules(SPICE_PKGCONFIG REQUIRED
	spice-protocol
	nettle
	hogweed
)

add_definitions(-D USE_NETTLE)

add_library(purespice STATIC
	src/spice.c
	src/rsa.c
	src/queue.c
)

target_link_libraries(purespice
	${SPICE_PKGCONFIG_LIBRARIES}
	gmp
)

target_include_directories(purespice
	PUBLIC
		$<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>
		$<INSTALL_INTERFACE:include>
	PRIVATE
		src
		${SPICE_PKGCONFIG_INCLUDE_DIRS}
)

=== client/displayservers/Wayland/CMakeLists.txt ===
--- 
+++ 
@@ -9,8 +9,33 @@
 #pkg_check_modules(DISPLAYSERVER_Wayland_OPT_PKGCONFIG
 #)
 
+set(displayserver_Wayland_SHELL_SRC "")
+
+if (ENABLE_LIBDECOR)
+	pkg_check_modules(DISPLAYSERVER_Wayland_LIBDECOR REQUIRED
+		libdecor-0.1
+	)
+	list(APPEND DISPLAYSERVER_Wayland_PKGCONFIG_LIBRARIES ${DISPLAYSERVER_Wayland_LIBDECOR_LIBRARIES})
+	list(APPEND DISPLAYSERVER_Wayland_PKGCONFIG_INCLUDE_DIRS ${DISPLAYSERVER_Wayland_LIBDECOR_INCLUDE_DIRS})
+	list(APPEND displayserver_Wayland_SHELL_SRC shell_libdecor.c)
+	add_definitions(-D ENABLE_LIBDECOR)
+else()
+	list(APPEND displayserver_Wayland_SHELL_SRC shell_xdg.c)
+endif()
+
 add_library(displayserver_Wayland STATIC
+	clipboard.c
+	cursor.c
+	gl.c
+	idle.c
+	input.c
+	output.c
+	poll.c
+	state.c
+	registry.c
 	wayland.c
+	window.c
+	${displayserver_Wayland_SHELL_SRC}
 )
 
 target_link_libraries(displayserver_Wayland
@@ -47,6 +72,12 @@
 file(MAKE_DIRECTORY "${CMAKE_BINARY_DIR}/wayland")
 include_directories("${CMAKE_BINARY_DIR}/wayland")
 wayland_generate(
+    "${WAYLAND_PROTOCOLS_BASE}/stable/xdg-shell/xdg-shell.xml"
+    "${CMAKE_BINARY_DIR}/wayland/wayland-xdg-shell-client-protocol")
+wayland_generate(
+    "${WAYLAND_PROTOCOLS_BASE}/unstable/xdg-decoration/xdg-decoration-unstable-v1.xml"
+    "${CMAKE_BINARY_DIR}/wayland/wayland-xdg-decoration-unstable-v1-client-protocol")
+wayland_generate(
     "${WAYLAND_PROTOCOLS_BASE}/unstable/relative-pointer/relative-pointer-unstable-v1.xml"
     "${CMAKE_BINARY_DIR}/wayland/wayland-relative-pointer-unstable-v1-client-protocol")
 wayland_generate(

=== client/displayservers/X11/CMakeLists.txt ===
--- 
+++ 
@@ -7,11 +7,16 @@
 	xi
 	xfixes
 	xscrnsaver
+	xinerama
 )
 
 add_library(displayserver_X11 STATIC
 	x11.c
+	atoms.c
+	clipboard.c
 )
+
+add_definitions(-D GLX_GLXEXT_PROTOTYPES)
 
 target_link_libraries(displayserver_X11
 	${DISPLAYSERVER_X11_PKGCONFIG_LIBRARIES}

=== client/renderers/EGL/CMakeLists.txt ===
--- 
+++ 
@@ -22,6 +22,9 @@
 	shader/fps.vert
 	shader/fps.frag
 	shader/fps_bg.frag
+	shader/help.vert
+	shader/help.frag
+	shader/help_bg.frag
 	shader/alert.vert
 	shader/alert.frag
 	shader/alert_bg.frag
@@ -31,9 +34,13 @@
 	shader/splash_logo.frag
 )
 
+make_defines(
+	"${CMAKE_CURRENT_SOURCE_DIR}/shader/desktop_rgb.frag"
+	"${CMAKE_CURRENT_BINARY_DIR}/shader/desktop_rgb.def.h"
+)
+
 add_library(renderer_EGL STATIC
 	egl.c
-	dynprocs.c
 	egldebug.c
 	shader.c
 	texture.c
@@ -41,10 +48,12 @@
 	desktop.c
 	cursor.c
 	fps.c
+	help.c
 	draw.c
 	splash.c
 	alert.c
 	${EGL_SHADER_OBJS}
+	"${EGL_SHADER_INCS}/desktop_rgb.def.h"
 )
 
 target_link_libraries(renderer_EGL

=== client/renderers/OpenGL/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.0)
project(renderer_Opengl LANGUAGES C)

find_package(PkgConfig)
pkg_check_modules(RENDERER_OPENGL_PKGCONFIG REQUIRED
	gl
)

add_library(renderer_OpenGL STATIC
	opengl.c
)

target_link_libraries(renderer_OpenGL
	${RENDERER_OPENGL_PKGCONFIG_LIBRARIES}
	lg_common
	fonts
)

target_include_directories(renderer_OpenGL
	PRIVATE
		src
		${RENDERER_OPENGL_PKGCONFIG_INCLUDE_DIRS}
)

=== debian/changelog ===
looking-glass (0+b4+dfsg.1-1) unstable; urgency=medium

  * New upstream release

 -- Lennart Weller <lhw@ring0.de>  Thu, 26 Aug 2021 22:01:34 +0200

=== debian/control ===
Source: looking-glass
Section: net
Priority: optional
Maintainer: Lennart Weller <lhw@ring0.de>
Build-Depends: cmake,
               debhelper (>= 12),
               debhelper-compat (= 12),
               fonts-freefont-ttf,
               libfontconfig1-dev,
               libsdl2-dev,
               libsdl2-ttf-dev,
               libspice-protocol-dev,
               libx11-dev,
               nettle-dev,
               wayland-protocols
Standards-Version: 4.5.1
Homepage: https://looking-glass.hostfission.com
Vcs-Browser: https://salsa.debian.org/lhw-guest/looking-glass
Vcs-Git: https://salsa.debian.org/lhw-guest/looking-glass.git

Package: looking-glass-client
Architecture: amd64
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Enhances: qemu-system-x86, xen-hypervisor
Description: Low latency KVM FrameRelay implementation for VGA Passthrough
 LookingGlass enables you to use shared memory to pass rendered frames from a
 virtual machine back to the host system.
 .
 A LookingGlass Host implementation is required to run on the guest virtual
 machine. It is recommended that the client and host versions match. See the
 README.Debian for more information.

=== debian/rules ===
#!/usr/bin/make -f

export DH_VERBOSE = 1

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DEB_CFLAGS_MAINT_APPEND = -O3 -madx -msse4.1
export DPKG_EXPORT_BUILDFLAGS = 1

include  /usr/share/dpkg/pkg-info.mk
export DEB_VERSION

%:
	dh $@ --sourcedirectory=client

override_dh_auto_configure:
	dh_auto_configure -- -DOPTIMIZE_FOR_NATIVE=OFF -DENABLE_BACKTRACE=OFF

override_dh_install:
	dh_install --sourcedir=client

=== debian/watch ===
version=3
opts=dversionmangle=s/(0\+|\+dfsg\.\d)//,filenamemangle=s/.+\/(a|B)(\d\S*)\.tar\.gz/looking-glass-$1$2\.tar\.gz/ \
	https://github.com/gnif/LookingGlass/releases .*/(a|B)(\d\S*)\.tar\.gz
